int rectangleOfsetX [] ={22, 22, 22, 22, 7, 10, 9 , 4} ;
int rectangleOfsetY [] ={22, 22, 22, 22, 7, 11, 9 , 3} ;
int boxOfsetX [] ={-45, -45, -45, -45, 7, -21, 9 , -8} ;
int boxOfsetY [] ={-44, -44, -44, -44, 7, -20, 9, -7} ;

int imageOfsetX [] ={124, 83, 61, 48, 7, 30, 9 , 16} ;
int imageOfsetY [] ={106, 68, 50, 38, 7, 25, 9 , 13} ;
  
int labelOfsetX [] ={142, 91, 75, 61, 7, 41, 9 , 26} ;
int labelOfsetY [] ={144, 104, 88, 73, 7, 61, 9 , 53} ;
  
//*************************************

void getTimeNow ()
{  
#ifdef DS3231
DateTime now = rtc.now();
nowMinute = now.minute();
nowHour = now.hour();
numWeek = now.dayOfTheWeek(); 
numDay = now.day();
numMonth = now.month()-1; // month is 1 to 12
numYear = now.year();
#else
nowMinute = random (60) ;
nowHour = random (24) ;
numWeek = random (7) ;
numDay = random (31) ;
numMonth = random (12) ;
numYear = 2020+ random (12) ; ;
#endif
nowTime = nowHour*60 +  nowMinute ; // minute + 60* hour  : 0..1440-1
}

//*************************************

void  clockAdjust ()
{
#define resolutionClick 6 // Matrice of buttons
ifRTC() ;
itp.background (128, 179, 255); // blue
itp.colorTextFrames (128, 0, 0); // Maroon

checkBoard (resolutionClick) ;
//demoGrid (204, 153, 255);
itp.textSize (60) ;
itp.labelText ("Clock adjust", 300,60); 
//lock (415, 650,64) ;
//placeClock (447, 666,64) ;
placeAdjustDate () ;
timeBar () ; // Checking mouse
} 

//*************************************

int clockAdjustOrder ()
{
int lp = -1;
//mouseDebug ();  
int clickPosition =  (xMouse*resolutionClick/xSize)  + ((yMouse*resolutionClick/ySize) * resolutionClick);
switch (clickPosition)
      {        
      case (8) : //(positions[0]):
        setRTC (0, 0, 1, 0, 0);
      break;
      case (8+resolutionClick): 
        setRTC (0, 0, -1, 0, 0);
      break;
      case (9) : //(positions[0]):
        setRTC (0, 1, 0, 0, 0);
      break;
      case (9+resolutionClick): 
        setRTC (0, -1, 0, 0, 0);
      break;
      case (10) : //(positions[0]):
        setRTC (1, 0, 0, 0, 0);
      break;
      case (10+resolutionClick): 
        setRTC (-1, 0, 0, 0, 0);
      break;        
      case (26) : //(positions[0]):
        setRTC (0, 0, 0, 1, 0);
      break;
      case (26+resolutionClick): 
        setRTC (0, 0, 0, -1, 0);
      break;
      case (27) : //(positions[0]):
        setRTC (0, 0, 0, 0, 1);
      break;
      case (27+resolutionClick): 
        setRTC (0, 0, 0, 0, -1);
      break;
      default : 
         lp=999 ; // > maxTime+1;
      break;    
    }
return (lp); // Reset counting
}


//*************************************

void timeBar ()  // Checking mouse
{
#define  maxTime  150 // 30 seconds
for (int lp=0; lp<maxTime; lp++)
  {
  getTimeNow () ;
  needle(700, 650, 100);  // Center
    placeClock (453, 668,64) ;
  if (lp==0)
      { // Time bar //
      itp.colorTextFrames (179, 255, 179) ; // Light Green 
      itp.rectangleCorners (0,90, xSize-1, 120);
      }    
  itp.colorTextFrames (20, 82, 20) ; // dark Green for bars (changed by placeClock)
  itp.rectangleDelta ((lp*(xSize/(maxTime+5))),90, ((xSize/maxTime)-3), 30); 
  if (checkMouse() != 0)      
      lp = clockAdjustOrder () ; 
  delay (190);              
  }
}

//*************************************

void setRTC (int deltaYear, int deltaMonth, int deltaDay , int deltaHour, int deltaMin)
{
#ifdef DS3231
DateTime now = rtc.now();
rtc.adjust(DateTime (deltaYear+ now.year(), deltaMonth+now.month(), deltaDay+now.day(),(24+deltaHour+now.hour())%24 , (60+deltaMin+now.minute())%60, 0));
placeAdjustDate () ;
#else
itp.labelText ("No Clock adjust in demo mode", 60,500); 
#endif
}

//*************************************
