//***********************************//
//     Sand Box  Processing          //
//***********************************//
//        Christian Couderc          //
//         www.voilec.com            //
//***********************************//
//   220204

int width = 1000 ;
int height = 1000 ;

color moonColor = 255;//#ffe699;
color bgColor = #1C1B2F;
float radius = width/2;
int frames = 250;
int columns = 4;
int rows = 5;
int cell = 108;
float delay = 1000;
float t ;
PImage img;

float cx1 ; //   The x-coordinate of 1st control point
float cy1 ; //   The y-coordinate of 1st control point
float cx2 ; // The x-coordinate of 2nd control point
float cy2 ; //   The y-coordinate of 2nd control point
float x ;   //  The x-coordinate of anchor point
float y ;   // The y-coordinate of anchor point 
int delta=20;


int   extX=-100 ;
int   intX= 150 ;

//float []xP = {random (width), random (width), random (width), random (width),  random (width), random (width), random (width), random (width)};
//float []yP = {random (width), random (width), random (width), random (width),  random (width), random (width), random (width), random (width)};
float []xP = {width/2   , extX  , extX      , width/2      ,  intX    , intX        , width/2};
float []yP = {delta     , 100    , height-100   , height-delta ,  height-100    , 100 ,  delta };
//*************************************************  3 anc ********************************  6 anc
int nb;
// **************************************************
void settings()
{size (width, height);}
// **************************************************
void setup() 
{
//img =loadImage ("..//FullMoon_800.jpg");  

noStroke(); 
//ellipseMode(CENTER);
//fill (64,0,0);
//stroke (0,255,0); // line color
print ("Array length = ");
println (xP.length);
drawLines ();delay (1000);}

// ************************************
void draw() 
{
drawBezier ();
}
// ************************************ 

void drawBezier ()
{
background (200);
fill (128, 191, 255); // light blue
nb=0;
beginShape();
vertex (xP[nb], yP[nb++]);
//bezierVertex (1st control point, 2nd control point, anchor point );
bezierVertex (xP[nb], yP[nb++],   xP[nb], yP[nb++],  xP[nb], yP[nb++]);
bezierVertex (xP[nb], yP[nb++],   xP[nb], yP[nb++],  xP[nb], yP[nb++]);
endShape();
plotPoints(); 
checkMouse ();
noFill();
circle (width/2, height/2, width-10);
}

// ************************************
void drawLines ()
{
nb=0;
while (nb<xP.length)
  {
  fill (255, 204, 102);
  stroke (255,0,0); // line color
//  fill (0,64,0);
  if (nb!=0)
  line (xP[nb-1], yP[nb-1], xP[nb], yP[nb]);
  nb++;
  }
plotPoints();  
}
// ************************************

void plotPoints()
{
nb=0;
while (nb<xP.length)
  {
  fill (255, 204, 102);
  circle (xP[nb], yP[nb], 50);
  stroke (255,0,0); // line color
  fill (0,64,0);
  textSize (32);
  text (nb, xP[nb]-8, yP[nb]+10);    
  text (nb, xP[nb]-8, yP[nb]+10);  
  textSize (16);
  fill (26, 26, 255);
  text (int(xP[nb]), xP[nb]-12, yP[nb]-12);  
  text (int(yP[nb]), xP[nb]-12, yP[nb]+22);    
  nb++;
  }
}  

// ************************************

void checkMouse ()
{
int curX = mouseX ;
int curY = mouseY ; 
int tol = 15;
line (curX, 0, curX, height);
line (0,curY, height, curY);
nb=0;
fill (153, 255, 102); // light green
boolean rec=false ;
while ((nb<xP.length)&& (rec==false))
  {
  if ((curX>xP[nb]-tol) && (curX<xP[nb]+tol) &&(curY>yP[nb]-tol) &&(curY<yP[nb]+tol))
    {
    rec=true;
   if (mousePressed)
      {
      fill (255, 102, 102); // light red
      xP[nb]=curX;
      yP[nb]=curY;
      }
    else
      fill (153, 255, 102); // light green
    circle (xP[nb], yP[nb], 50);
    }
  nb++;
  }
}

// ************************************

     
/*
float cx1 ;      The x-coordinate of 1st control point
float cy1 ;     The y-coordinate of 1st control point
float cx2 ;    The x-coordinate of 2nd control point
float cy2 ;     The y-coordinate of 2nd control point
float x ;     The x-coordinate of anchor point
float y ;     The y-coordinate of anchor point 
*/

void bez ()
{
int deltaX = 130;
int deltaY = 40;
int curX = mouseX ;
int curY = mouseY ; 
int posX = int( 4*mouseX -deltaX);
image(img, 0, 0);
fill(0, 255, 0);
//background (32);  
text (curX, 10, 30);
text (curY, 10, 70);
text (posX, 10, 110);
noFill();
beginShape();
vertex(width/2, 0);// // vertex(30, 20);

cx1 = posX;//380 ;
cy1 = deltaY;//mouseY ; //0 ;
cx2 = posX;//width ;
cy2 = width-deltaY ; //mouseY ;//75 ;
x = width/2 ;
y = height;

/*
if (mouseX<2*deltaX)
{
bezierVertex(cx1, cy1, cx2, cy2, x, y); // left moving
fill(255, 0, 0);
bezierVertex(width+deltaX, cy2, width+deltaX, cy1, width/2, 0); // right fixed
}

else */
{
float leftQ=   mouseX-2 *deltaX ;

//bezierVertex(width/2-cx1, cy1, width/2-cx2, cy2, x, y); // right moving
//bezierVertex(200-cx1/2, cy1, 200-cx2/2, cy2, x, y); // right moving
//bezierVertex(200, cy1, 200, cy2, width/2, height); // right moving
//bezierVertex(deltaX, cy1,deltaX, cy2,width/2, height);
//bezierVertex(-250, curY,+250, cy2,width/2, height);
//bezierVertex(-250, 77,+250, cy2,width/2, height);
bezierVertex(-250, 77,0, 800,width/2, height);
fill(255, 0, 0);
//bezierVertex(-deltaX, cy1,-deltaX, cy2, width/2, height); // left fixed
//bezierVertex(deltaX, cy1,deltaX, cy2, width/2, height); // left fixed
//bezierVertex(deltaX, cy1,deltaX, cy2, width/2, 0); // left fixed
//bezierVertex(0, cy1,0, cy2, width/2, 0); // left fixed
//bezierVertex(curX, curY-deltaY,curX+deltaY, curY, width/2, 0); // left fixed
//bezierVertex(curX-250, 400-deltaY,curX-250, 400, width/2, 0); // left fixed
bezierVertex(0, 400-deltaY,0, 400, width/2, 0); // left fixed

//bezierVertex(0, cy1,0, cy2, 0, 0); // left fixed
//bezierVertex(0, cy1,0, cy2, width/2, curX); // left fixed
//bezierVertex(0, cy1,0, cy2, curX, ); // left fixed
//vertex(width/2, 0);
}
endShape();

noFill();
stroke (0,255,0);
circle (width/2, height/2, width-7);
delay (300);
}
