void ifRTC() 
{
#ifdef DS3231
  return ;
#endif  
itp.background (204, 204, 255) ; 
itp.colorTextFrames(230, 0, 0) ;
itp.textSize (64) ;
itp.labelText ("DS3131 in not present ?",120, 100);
itp.labelText (">>>> DEGRADED MODE <<<<",50, 180);
itp.textSize (40) ;
itp.colorTextFrames(0, 179, 0) ;
itp.labelText ("if RTC and <Adafruit driver> are OK", 150,600);
itp.labelText ("in first line curve_test.ino", 230,650);
itp.labelText ("uncomment : //#define DS3231", 200, 700);
delay (3000);
}

//*************************************

void loopWaiting ()
{
for (int lp=0; lp<600 ; lp++) // Delay 30 sec = 600*50
  {
  if (checkMouse() != 0)
    break;
  delay (50) ; 
  if(lp%64== 0) // Activity marker
    digitalWrite (led_pin, LOW); // On
  else
    digitalWrite (led_pin, HIGH); 
  }
if (stateMouse != 0)
    mainPanelInterpreter () ;  
}

//*************************************

void beep (int frequency, int duration)  // duration > 1 ms
{
float interval = 500000/frequency ;  // interval 500 microsec for 1 kHz

long topMicro1= micros () ;
while ((micros () - topMicro1)< (long)duration*1000)
  {
  digitalWrite (buzzer, !digitalRead(buzzer)) ; 
  long topMicro= micros () ;
  while ((micros () - topMicro)< interval)  ;
  }
digitalWrite (buzzer, LOW) ; 
}

//*************************************

void pinPon (int8_t loops)
{
for (int i=1; i<2*loops; i++) 
  {
  for (int j=1; j<5 ;j++) 
    {
    beep (196 * j * (2-j%2),20)  ; // 196 Sol 3
    }
   Serial.println();
   } 
}

//*************************************

void soundDecreaseLevel ()
{
for (int i = 0 ; i < 12 ; i++)
    beep ( 41.20 * (1 + 4 * (i % 2)) , 25) ; // 41.20 Mi 0 // 164.83 Mi 3
}

//*************************************
