int width = 1000 ;
int height = 1000 ;
PImage img;
int imageSize = 800; //square

float moonCycle= 29.5;
int radius = 396; // imageSize/2;

float moonCenterX = width/2;
float moonCenterY = height/2;

color moonColor = 255;//#ffe699;
color bgColor = #1C1B2F;

/*int frames = 250;
int columns = 4;
int rows = 5;
int cell = 108;
float delay = 1000;
float t ;*/



/*float cX1 ; //   The x-coordinate of 1st control point
float cy1 ; //   The y-coordinate of 1st control point
float cX2 ; // The x-coordinate of 2nd control point
float cy2 ; //   The y-coordinate of 2nd control point
float x ;   //  The x-coordinate of anchor point
float y ;   // The y-coordinate of anchor point */
//int delta=20;
int movX;

int extX=-100 ;
int intX= 150 ;
int deltaCtrY =radius-10;


float []xP = {moonCenterX   , extX  , extX      , moonCenterX      ,  movX    , movX        , moonCenterX };
float []yP = {moonCenterY-radius      , moonCenterY-deltaCtrY     , moonCenterY+deltaCtrY   , moonCenterY+radius , moonCenterY+deltaCtrY ,  moonCenterY-deltaCtrY    ,   moonCenterY-radius };
//***********  0: start *** 1: ctrl 1/1 *** 2: ctrl 2/1 *** 3: anc 1 *** 4: ctrl 1/2 ***  5: ctrl 2/2 *** 6: anc 2
int nb;
// **************************************************
void settings()
{size (width, height);}
// **************************************************
void setup() 
{
img =loadImage ("..//FullMoon_800g.gif");  

noStroke(); 
print ("Array length = ");
println (xP.length);
delay (1000);}

// ************************************
void draw() 
{
float day= moonCycle * mouseX/width ;
drawBezier (day);
line (mouseX, 0, mouseX, height);
noFill();
stroke (0,255,0);
circle (width/2, height/2, 10);
int cursor= (width-imageSize)/2+ int(day*imageSize/moonCycle) ;
line (cursor, 0, cursor, height);
delay (200);
}
// ************************************ 

void drawBezier (float day)
{
background (200);
image(img, (width-imageSize)/2, (height-imageSize)/2); 
//tint(255, mouseY/4);  // Apply transparency without changing color
noStroke();

fill (128, 191, 255); // light blue
int deltaCtrY= radius;//-100; // distance from center for control points
int depasseX = 136;
if (day>moonCycle/2) // full moon
  {
  movX = int((5*radius+100 )*(moonCycle-day)/moonCycle)-24; // Moving curve
  xP[1] = moonCenterX+radius+ depasseX; //depasseX; // Fixed curve 
  }
else
  {
  movX = int(((2*radius) +240)*(moonCycle-day*2)/(moonCycle)); // Moving curve
  xP[1] = moonCenterX-radius-depasseX; // Fixed curve
  }
  xP[2] = xP[1] ;
  xP[4] = movX;
  xP[5] = xP[4] ;
  
textSize (24);
fill (255,0,0);
text (int(day),10,20);

int greyChannel= 3*(15-abs(int(day-moonCycle/2))) ; // Grey
fill (greyChannel, greyChannel, greyChannel); // Grey
nb=0;
beginShape();
vertex (xP[nb], yP[nb++]);
bezierVertex (xP[nb], yP[nb++],   xP[nb], yP[nb++],  xP[nb], yP[nb++]);
bezierVertex (xP[nb], yP[nb++],   xP[nb], yP[nb++],  xP[nb], yP[nb++]);
endShape();
}

// ************************************
