/* CC test CNA 

***********************  
*                     *
*  Christian Couderc  *
*                     * 
*   www.voilec.com    *
*                     *   
***********************  

from arduino.h
#define PI 3.1415926535897932384626433832795
#define HALF_PI 1.5707963267948966192313216916398
#define TWO_PI 6.283185307179586476925286766559
#define DEG_TO_RAD 0.017453292519943295769236907684886
#define RAD_TO_DEG 57.295779513082320876798154814105
*/


#define color1 RED
#define color2 BLUE
#define color3 GRAY
#define color4 BLACK
#define color5 WHITE
#define color6 GREEN
#define color7 BROWN
#define color8 YELLOW

#include <string.h>
char buffer[64];
int x1,y1,x2,y2,x4,y4,alpha ;
float delta = -0.05 ;
float k = TWO_PI/60 ;
int alphaS =6*random(60) ; 
int alphaM =6*random(60) ; 
int alphaH =6*random(12) ; 
int x[8] ; // x0,x1,... x7,
int y[8] ; // y0,y1,... ,y7

#include "Nextion.h"
// Instanciation des objects : page ID,  component ID , name
NexPage pageIntro = NexPage (0,0,"pageIntro");

// *********************************************************

void setup()
{
nexInit();  // Initialisation de la librairie ITEAD pour Nextion.
nexSerial.begin(115200);  // Start serial comunication to Nextion at baud=115200  
//t0.setText(""); // Very important to awake Nextion
 delay (5000) ;
 Serial.begin(115200) ;
Serial.println ("\n\n\n\nTest Rolex\n") ;  

//nexSerial.print("ref 0") ;  //  Refresh all current page
//close();
//nexSerial.print("cls 0");
//close();
}

// *********************************************************

void loop()
{
alphaS+=6  ;
if (alphaS==360)
  {
  alphaS=0 ;
  }
if (alphaS%18==0)
  {
  alphaM+=6 ;
  }
if (alphaS%30==0)
  {
  alphaH+=6 ;
  }


//send_to_nextion("cls 0");
send_to_nextion("pic 0,0,23");   // Recharge image fond
//
// ///////////////////////////// hour ///////////////////////////////////////////////////////////////

calcPointA (0, 20, alphaH); // Arriere rectangle blanc
calcPointA (1, 90, alphaH); // Centre cercle blanc Y
calcPointA (2, 150, alphaH); // Pointe heure
calcPointA (6, 140, alphaH); // Pointe heure blanc
////

for (int cnt =-21 ; cnt<22 ; cnt++)
  { // cnt
 calcPointR (3, cnt, alphaH+15); // Delta heure
  x[4] = x[0] + x[3];
  y[4] = y[0] + y[3] ; 
  x[5] = x[1] + x[3];
  y[5] = y[1] + y[3] ;
  ////
  ////

  if ((abs (cnt))<15)
      {
      sprintf(buffer,"line %03d,%03d,%03d,%03d,WHITE", x[5],y[5],x[6],y[6]) ; // Pointe extérieure blanc
      send_to_nextion(buffer);
      }
   else
      {
      sprintf(buffer,"line %03d,%03d,%03d,%03d,BLUE", x[5],y[5],x[2],y[2]) ; // Pointe extérieure
      send_to_nextion(buffer);
//Serial.println (buffer) ;
sprintf(buffer,"line %03d,%03d,%03d,%03d,BLUE", x[5],y[5],x[6],y[6]) ; // Pointe extérieure
      send_to_nextion(buffer);
      }
  
  if ((abs (cnt))<8)
    {
    sprintf(buffer,"line %03d,%03d,%03d,%03d,WHITE", x[4],y[4], x[5],y[5]) ;   // Blanc central
    }
  else if ((abs (cnt)) <13)
    {
    sprintf(buffer,"line %03d,%03d,%03d,%03d,BROWN", x[4],y[4], x[5],y[5]) ; 
    }
  send_to_nextion(buffer);
  
   if ((abs (cnt)) <13)
    {
    sprintf(buffer,"line 400,240,%03d,%03d,RED", x[4],y[4]) ; // Pointe centre
    send_to_nextion(buffer);
    }

////
  } // cnt

sprintf(buffer,"cirs %03d,%03d,25,BLUE", x[1],y[1]) ; // Cercles heure
delay (50) ; // To avoid crash of serial buffer
send_to_nextion(buffer);
//delay (20) ;
sprintf(buffer,"cirs %03d,%03d,20,WHITE", x[1],y[1]) ; 
send_to_nextion(buffer);

  
//  Construction du Y central <<<<<<<<<
//calcPointA (1, 90, alphaH); // Centre cercle blanc Y
calcPointR (5, -20, alphaH); // branche interieure Y
calcPointR (3, 20, alphaH-10); // branche droite Y
calcPointR (4, 20, alphaH+10); // branche gauche Y
x[5]+=x[1] ;
y[5]+=y[1] ;
x[3]+=x[1] ;
y[3]+=y[1] ;
x[4]+=x[1] ;
y[4]+=y[1] ;


//for (int cnt =-21 ; cnt<22 ; cnt++)  // Epaississement Y
  { // << cnt2
    
    sprintf(buffer,"line %03d,%03d,%03d,%03d,BROWN", x[1],y[1], x[5],y[5]) ; 
    send_to_nextion(buffer);
    sprintf(buffer,"line %03d,%03d,%03d,%03d,RED", x[1],y[1], x[3],y[3]) ; 
    send_to_nextion(buffer);

    
    sprintf(buffer,"line %03d,%03d,%03d,%03d,BLUE", x[1],y[1], x[4],y[4]) ; 
    send_to_nextion(buffer);
  } // >> cnt2   
   
   // Serial.println (buffer) ;
    //  Construction du Y central >>>>>>>>>

////
// ///////////////////////////// minute ///////////////////////////////////////////////////////////////

calcPointA (0, 50, alphaM); // Arriere rectangle blanc
calcPointA (1, 150, alphaM); // Extérieur rectangle blanc
calcPointA (2, 200, alphaM); // Pointe minute
////
for (int cnt =-12 ; cnt<13 ; cnt++)
  { // cnt
  calcPointR (3, cnt, alphaM+15); // Delta minute
  x[4] = x[0] + x[3];
  y[4] = y[0] + y[3] ; 
  x[5] = x[1] + x[3];
  y[5] = y[1] + y[3] ;
  ////
  sprintf(buffer,"line 400,240,%03d,%03d,BLUE", x[4],y[4]) ; // Pointe centre
  send_to_nextion(buffer);
  ////
  sprintf(buffer,"line %03d,%03d,%03d,%03d,BROWN", x[5],y[5],x[2],y[2]) ; // Pointe extérieure
  send_to_nextion(buffer);
  ////
  if (abs (cnt)<6)
    {
    sprintf(buffer,"line %03d,%03d,%03d,%03d,WHITE", x[4],y[4], x[5],y[5]) ;   
    }
  else
    {
    sprintf(buffer,"line %03d,%03d,%03d,%03d,GREEN", x[4],y[4], x[5],y[5]) ; 
    }
  send_to_nextion(buffer);
  } // cnt


// ///////////////////////////// Trotteuse

calcPointA (0, -70, alphaS); // Arriere trotteuse
calcPointA (1, 140, alphaS); // Cercle trotteuse
calcPointA (2, 235, alphaS); // Pointe trotteuse
//

//
//
for (int cnt =-5 ; cnt<6 ; cnt++)
  { // cnt
  calcPointR (3, cnt, alphaS+15); // Delta trotteuse
  x[4] = x[0] + x[3];
  y[4] = y[0] + y[3] ; 
  x[5] = x[1] + x[3];
  y[5] = y[1] + y[3] ;
  //

  sprintf(buffer,"line %03d,%03d,%03d,%03d,YELLOW", x[4],y[4], x[5],y[5]) ; 
  send_to_nextion(buffer);
  //
  sprintf(buffer,"line %03d,%03d,%03d,%03d,RED", x[5],y[5], x[2],y[2]) ; 
  send_to_nextion(buffer);
  //
  } // cnt
//
sprintf(buffer,"cirs %03d,%03d,15,GREEN", x[1],y[1]) ; 
send_to_nextion(buffer);
sprintf(buffer,"cirs %03d,%03d,10,WHITE", x[1],y[1]) ; 
send_to_nextion(buffer);
sprintf(buffer,"cirs %03d,%03d,15,GREEN", x[0],y[0]) ; 
send_to_nextion(buffer);
sprintf(buffer,"cirs 400,240,15,BLUE", x[0],y[0]) ; 
send_to_nextion(buffer);
sprintf(buffer,"cirs 400,240,5,WHITE", x[0],y[0]) ; 
send_to_nextion(buffer);
delay (1000) ;
}
// *********************************************************

void calcPointA (int indx, int ray, int alpha)
{
alpha %= 360 ;
x[indx] = 400 + (ray * sin (k*alpha));
y[indx] = 240 + (ray * cos (k*alpha));
}

// *********************************************************

void calcPointR (int indx, int ray, int alpha)
{
alpha %= 360 ;
x[indx] =  ray * sin (k*alpha);
y[indx] =  ray * cos (k*alpha);
}

// *********************************************************

 
void send_to_nextion(String ss) // Sends nextion string and terminates it
{
nexSerial.print(ss);
nexSerial.write(0xff);  
nexSerial.write(0xff);
nexSerial.write(0xff); 
}

//////////////////////////


// *********************************************************
